diff --git a/.gitignore b/.gitignore
index 719f954..c935307 100644
--- a/.gitignore
+++ b/.gitignore
@@ -24,3 +24,7 @@ ui/uitest
 /missing
 /compile
 *~
+*.swp
+*.info
+TAGS
+tags
diff --git a/ChangeLog b/ChangeLog
index c29935b..f0ee518 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,86 @@
+2020-07-17  Matt Henry  <mcthenry+gnu@gmail.com>
+
+	* 1.3.0: bumped the version to 1.3.0
+
+	* GUI: updated GNU Robots to GTK3
+
+	* Scheme/Build: Configured to prefer Guile 2.2 and fall back to
+	2.0.
+
+2020-07-07  Matt Henry  <mcthenry+gnu@gmail.com>
+
+	* overhaul2 branch changes as of 2020-07-07:
+
+	* Code: Refactored code to reduce dependencies (much less of a web
+	of #includes)
+
+	* Code: Removed unneeded imports
+
+	* Code: Compiler warnings reduced through appropriate casting
+
+	* Code: Marked functions as static if only used in local .c file
+
+	* Code: Refactored file searching in main.c into a function using
+	the environment variable and the #define from configs.h
+
+	* Code: G_ADD_PRIVATE being used for private data throughout
+	(eliminates compiler warnings for deprecated features and
+	standardizes on latest method).
+
+	* Code: Signals are now the only means of communication between the UI
+	and the Map and Robot objects (no calling from unexpected threads)
+
+	* Commandline: modified GNU Robots to use GOption commandline
+	processing.
+
+	* Commandline/GTK: modified GNU Robots to accept (and process)
+	standard GTK commandline options.
+
+	* GUI: Added a menu bar containing File/Open Map; File/Quit;
+	Scheme/Interrupt and Help/About
+
+	* GUI: user can load a map using a GTK+ file picker widget
+
+	* GUI for robot statistics updated to use a normal GTK+ widget.
+	Robot statistics show deltas using color to highlight up/down
+	changes in the quantity.
+
+	* GUI: Delay is now done in the api.c file rather than in grobot.c.
+
+	* GUI: Cairo is now being used for the arena drawing (the old PixMap
+	method is deprecated)
+
+	* GUI: Map filename is now being displayed in the GUI
+
+	* GUI: Animation is now done using timers (no more sleeping on the GUI
+	thread).
+
+	* Scheme/GUI: added a menu option to allow the user to interrupt
+	scheme code.
+
+	* Scheme: added a new function robot-set-move-delay! to turn
+	on/off the move delay.
+
+	* Scheme: added getters for base action costs
+	(e.g. robot-get-move-energy-cost).
+
+	* Scheme: added getters for robot statistics
+	(e.g. robot-get-energy).
+
+	* Map Files: maps can now specify one or more locations where they want
+	the robot to spawn (it doesn't always have to be (1, 1)) by
+	putting an R in the location.
+
+	* Map: maps can now support orientation for any thing (sets the
+	stage for moving baddies, bullets, missiles, whatever).
+
+	* Documentation: added texi documentation (can build .info files,
+	.html files, ...), including adding Invoking gnurobots, function
+	and concept indices, ...
+
+	* Documentation: added doxygen-style documentation to grobot.c,
+	grobot.h and map.h
+
 2008-08-03  Bradley Smith  <brad@brad-smith.co.uk>
 
 	Adjust build system.
diff --git a/configure.ac b/configure.ac
index 01b7486..5cf3eb3 100644
--- a/configure.ac
+++ b/configure.ac
@@ -17,7 +17,7 @@
 ## along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.
 
 dnl Process this file with autoconf to produce a configure script.
-AC_INIT([GNU Robots], [1.2.0], [gnurobots@gnu.org], [gnurobots])
+AC_INIT([GNU Robots], [1.3.0], [gnurobots@gnu.org], [gnurobots])
 AC_PREREQ([2.59])
 AM_CONFIG_HEADER([config.h])
 AC_CONFIG_SRCDIR([include/api.h])
@@ -26,12 +26,16 @@ AM_INIT_AUTOMAKE
 dnl Checks for programs.
 AC_PROG_CC_C99
 
+dnl Check for Guile.  Prefer Guile 2.2 but use 2.0 if available.
+GUILE_PKG([2.2], [2.0])
 GUILE_FLAGS
 
-PKG_CHECK_MODULES(GLIB2, glib-2.0 >= 2.35.1)
+dnl GLIB and GTHREAD
+PKG_CHECK_MODULES(GLIB2, glib-2.0 >= 2.38)
 PKG_CHECK_MODULES(GTHREAD2, gthread-2.0 >= 2.4)
-PKG_CHECK_MODULES(GTK2, gtk+-2.0 >= 2.4)
-PKG_CHECK_MODULES(VTE, vte)
+
+AM_PATH_GTK_3_0
+PKG_CHECK_MODULES(VTE, [vte-2.91])
 
 schemedir="\$(pkgdatadir)/scheme"
 AC_SUBST(schemedir)
@@ -51,12 +55,6 @@ You need openpty to build this program.
 
 ]))
 
-AC_CHECK_LIB(guile-2.0, scm_to_locale_string, [], AC_MSG_ERROR([
-
-You need guile 2.0 to build this program.
-
-]))
-
 dnl Checks for typedefs, structures, and compiler characteristics.
 AC_C_CONST
 
diff --git a/contrib/mapedit.c b/contrib/mapedit.c
index d694941..9af2d18 100644
--- a/contrib/mapedit.c
+++ b/contrib/mapedit.c
@@ -819,7 +819,7 @@ message_box (char *title, char *text)
 {
   GtkWidget *label, *window, *button, *box;
 
-  window = gtk_window_new (GTK_WINDOW_DIALOG);	/* make window */
+  window = gtk_window_new (GDK_WINDOW_DIALOG);	/* make window */
 
   gtk_window_set_title (GTK_WINDOW (window), title);
 
diff --git a/doc/Makefile.am b/doc/Makefile.am
index ec000f9..4496cf5 100644
--- a/doc/Makefile.am
+++ b/doc/Makefile.am
@@ -18,3 +18,5 @@
 EXTRA_DIST =\
  contrib\
  Robots-HOWTO
+
+info_TEXINFOS = gnurobots.texi
diff --git a/doc/Robots-HOWTO b/doc/Robots-HOWTO
index 2920842..98ace5f 100644
--- a/doc/Robots-HOWTO
+++ b/doc/Robots-HOWTO
@@ -190,6 +190,9 @@ print nothing.
 			       something (a baddie, or even a prize or
 			       food) then the function returns a true
 			       (`#t') value.
+---------------------------------------------------------------------
+ robot-is-alive?       0       Returns #t if the robot is able to take
+                               (i.e. both energy and shields are > 0).
 ---------------------------------------------------------------------
  robot-stop            0       Exits GNU Robots immediately.
 ---------------------------------------------------------------------
@@ -201,6 +204,14 @@ print nothing.
 ---------------------------------------------------------------------
  robot-get-score       0       Returns the robot's score (how many
 			       prizes have been picked up.)
+---------------------------------------------------------------------
+ robot-set-move-delay! 0       Sets whether the system will delay 
+			       after the robot takes an action.  This
+			       is useful for keeping track of robot
+			       activity on the GUI.
+			       Defaults to #t (has delay).
+			       Set to #f to turn off the delay (i.e.
+			       to speed the robot up).
 =====================================================================
 
 
diff --git a/include/Makefile.am b/include/Makefile.am
index 75e1b2f..fcdb5b3 100644
--- a/include/Makefile.am
+++ b/include/Makefile.am
@@ -24,4 +24,5 @@ EXTRA_DIST = \
  ui-window.h \
  ui-window-private.h \
  ui-arena.h \
- ui-cmdwin.h
+ ui-cmdwin.h \
+ ui-status.h
diff --git a/include/api.h b/include/api.h
index eb58783..ae10e7d 100644
--- a/include/api.h
+++ b/include/api.h
@@ -20,23 +20,27 @@
 #ifndef _API_H
 #define _API_H
 
-#include <glib.h>
-#include <libguile.h>           /* GNU Guile high */
-
-void		api_init			(void);
-
-/* Functions */
-SCM		api_robot_turn 			(SCM s_n);
-SCM 		api_robot_move 			(SCM s_n);
-SCM 		api_robot_smell 		(SCM s_th);
-SCM 		api_robot_feel 			(SCM s_th);
-SCM 		api_robot_look 			(SCM s_th);
-SCM 		api_robot_grab 			(void);
-SCM 		api_robot_zap 			(void);
-SCM 		api_robot_stop 			(void);
+/** Send an interrupt to Guile causing it to stop processing and drop
+ *  to the debugger (if it's in an REPL call anyway).
+ *
+ * This is accomplished by generating the SIGUSR1 signal.
+ */
+void            api_interrupt   (void);
 
-SCM 		api_robot_get_shields 		(void);
-SCM 		api_robot_get_energy 		(void);
-SCM 		api_robot_get_score 		(void);
+/** Initialize the Guile environment in a newly created thread.
+ *
+ * Note: pass unprocessed program arguments (argc and argv) so that
+ * Guile can appropriately set its (command-line) data.
+ *  
+ * When Guile exits, it will call exit() on the program (terminating
+ * it).
+ *
+ * \param[in] argc The number of arguments Guile can processin in argv.
+ * \param[in] argv The arguments as strings.
+ * \param[in, out] in_robot the robot the API functions are meant to control.
+ *
+ * \returns a pointer to the GThread created.
+ */
+GThread*        api_init        (gint argc, gchar **argv, gpointer in_robot);
 
 #endif /* _API_H */
diff --git a/include/grobot.h b/include/grobot.h
index 60796a9..1c32ac3 100644
--- a/include/grobot.h
+++ b/include/grobot.h
@@ -21,74 +21,331 @@
 
 #include <glib-object.h>
 #include <glib.h>
-#include "ui-arena.h"
 #include "map.h"
 
 G_BEGIN_DECLS
 
+/** Normal GObject function to get the type (makes G_TYPE_ROBOT work,
+ * for instance).
+ */
+GType g_robot_get_type(void) G_GNUC_CONST;
+
 #define G_TYPE_ROBOT            g_robot_get_type()
+/** Use to test whether you have a valid GRobot*.
+ */
 #define G_IS_ROBOT(obj)         G_TYPE_CHECK_INSTANCE_TYPE ((obj),\
                                   G_TYPE_ROBOT)
 #define G_IS_ROBOT_CLASS(klass) G_TYPE_CHECK_CLASS_TYPE ((klass),\
                                   G_TYPE_ROBOT)
 #define G_ROBOT_GET_CLASS(obj)  G_TYPE_INSTANCE_GET_CLASS ((obj),\
                                   G_TYPE_ROBOT, GRobotClass)
+/** Use to cast to GRobot*.
+ */
 #define G_ROBOT(obj)            G_TYPE_CHECK_INSTANCE_CAST ((obj),\
                                   G_TYPE_ROBOT, GRobot)
 #define G_ROBOT_CLASS(klass)    G_TYPE_CHECK_CLASS_CAST ((klass),\
                                   G_TYPE_ROBOT, GRobotClass)
 
+/** Main type for robots in GNU Robots.
+ */
 typedef struct _GRobot GRobot;
 typedef struct _GRobotClass GRobotClass;
+typedef struct _GRobotPrivate GRobotPrivate;
+
+/** GRobot_stats is used to communicate the statistics of the robot at
+ * a point in time.
+ */
+typedef struct _GRobot_stats GRobot_stats;
+/** GRobot_change is used to communicate the statistics of the robot at
+ * across a change.  
+ *
+ * It includes both before- and after-change GRobot_stats so the
+ * consumer can calcaulate deltas.  
+ * It also includes a status_message indicating what caused the change
+ * (e.g. robot-move will be passed if the robot changes are the result
+ * of a move).
+ */
+typedef struct _GRobot_change GRobot_change;
 
+/** _GRobot_stats is used to communicate the statistics of the robot at
+ * a point in time.
+ */
+struct _GRobot_stats {
+  gint      x;       /*!< The robot's x-position. */
+  gint      y;       /*!< The robot's y-position. */
+  gint      dir;     /*!< The direction the robot is facing as defined in configs.h (NORTH, SOUTH, EAST, WEST). */
+  glong     turn;    /*!< Counter of the number of robot-actions the robot has taken. */
+  glong     score;   /*!< The robot's score. Score increases as the robot grabs prizes. */
+  glong     energy;  /*!< The robot's current energy. Energy is decreased when the robot takes actions. */
+  glong     shields; /*!< The robot's current shields.  Shields are depleted when the robot touches baddies or when the robot bumps into baddies or into walls. */
+  glong     shots;   /*!< The number of shots the robot has taken. */
+  glong     units;   /*!< Count of the number of times the robot has moved. */
+};
+
+/** _GRobot is used to hold the robot's instance data.
+ */
 struct _GRobot {
-  GObject   object;
-
-  gint      x;
-  gint      y;
-  gint      dir;
-  glong     score;
-  glong     energy;
-  glong     shields;
-  glong     shots;
-  glong     units;
-
-  UIArena *ui;
-  Map *map;
+  GObject   object;    /*!< Pointer to the robot's parent instance. */
+
+  GRobotPrivate *priv; /*!< Pointer to the robot's private data. */
 };
 
+/** _GRobotClass is used to hold the robot's class data.
+ */
 struct _GRobotClass {
-  GObjectClass parent_class;
+  GObjectClass parent_class; /*!< Pointer to the robot's parent class. */
 
   void (*death) (GRobot *robot);
 };
 
-/* some convenient macros */
-#define G_ROBOT_POSITION_X(robot)   ((robot)->x)
-#define G_ROBOT_POSITION_Y(robot)   ((robot)->y)
+/** Max length for a _GRobot_change.status_message.
+ */
+#define ROBOT_STATUS_MESSAGE_LEN 20
 
-/* this is a little weird, but 0 case doesn't actually matter
-   given how the code in grobot.c uses this macro... */
-#define sign(x)                     (x ? x/abs(x) : 0)
+/** _GRobot_change is produced by the "robot-stats" signal containing
+ * data describing the robot's stats before and after the change.
+ */
+struct _GRobot_change {
+  gchar status_message[ROBOT_STATUS_MESSAGE_LEN]; /*!< Text description describing the source of the change (e.g. "robot-move", "robot-turn", ...). */
+  GRobot_stats before_change; /*!< Stats of the robot before the change. */
+  GRobot_stats after_change;  /*!< Stats of the robot after the change. */
+};
 
-/* normal GObject stuff */
-GType g_robot_get_type(void) G_GNUC_CONST;
+/** \defgroup RConstructor Robot Constructor
+ * @{
+ */
 
-/* Our object functions */
-GRobot* g_robot_new(int x, int y, int dir, long score, long energy,
-        long shield, long units, long shots, UIArena *ui, Map *map);
+/** Creates a new GRobot.
+ *
+ * \param[in] energy is the robot's starting energy (should be a number > 0).  DEFAULT_ENERGY is a typical starting setting.
+ * \param[in] shield is the robot's starting shields (should be a number > 0).  DEFAULT_SHIELDS is a typical starting setting.
+ * \param[in] units is the starting value for units (typically 0).
+ * \param[in] shots is the starting value for shots (typically 0).
+ * \param[in] map is the map the robot will be moving around on.
+ *
+ * \returns a new GRobot*.
+ */
+GRobot* g_robot_new(long energy, long shield, long units, long shots,
+		    Map *map);
+
+/** @} */
+
+/** \defgroup RActions Robot Actions
+ * @{
+ *
+ * Robot actions are how the robot is moved around and takes action in
+ * GNU Robots.  Robot Actions consume energy.
+ */
 
-void        g_robot_turn            (GRobot *robot, gint num_turns);
+/** Turn the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot to turn.
+ * \param[in] num_turns the number of quarter turns to take.  Positive
+ * numbers turn clockwise; negative numbers turn counter-clockwise.
+ *
+ * \returns TRUE if the turn succeeds.  Note that it is possible for a
+ * turn to partially succeed (e.g. robot runs out of energy part way
+ * through a 5 num_turns turn).  In a partial move scenario, it returns
+ * FALSE, but the robot may have rotated from its original position.
+ */
+gboolean    g_robot_turn            (GRobot *robot, gint num_turns);
+/** Move the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot to move.
+ * \param[in] steps the number of spaces to move.
+ *
+ * \returns TRUE if the move succeeds.  Note that it is possible for a
+ * move to partially succeed (e.g. robot runs out of energy part way
+ * through a 5 step move).  In a partial move scenario, it returns
+ * FALSE, but the robot may have moved from its original position.
+ */
 gboolean    g_robot_move            (GRobot *robot, gint steps);
+/** Smell the spaces around the robot (NORTH, SOUTH, EAST, WEST and
+ * NORTH-EAST, NORTH-WEST and SOUTH-EAST and SOUTH-WEST).
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot doing the smelling.
+ * \param[in] str a string representing the item being smelled for.  This
+ *      is one of the things[] items in grobot.c ("space", "food",
+ *      "prize", "wall", "baddie", "robot").
+ *
+ * \returns TRUE if the thing is smelled.
+ */
 gboolean    g_robot_smell           (GRobot *robot, gchar *str);
+/** Feel the location in front of the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot doing the feeling.
+ * \param[in] str a string representing the item being felt for.  This
+ *      is one of the things[] items in grobot.c ("space", "food",
+ *      "prize", "wall", "baddie", "robot").
+ *
+ * \returns TRUE if the thing is felt.
+ */
 gboolean    g_robot_feel            (GRobot *robot, gchar *str);
+/** Look at the locations in front of the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot doing the looking.
+ * \param[in] str a string representing the item being looked for.  This
+ *      is one of the things[] items in grobot.c ("space", "food",
+ *      "prize", "wall", "baddie", "robot").
+ *
+ * \returns TRUE if the thing is seen.
+ */
 gboolean    g_robot_look            (GRobot *robot, gchar *str);
+/** Grab the item in the location in front of the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot doing the grabbing.
+ *
+ * \returns TRUE if the grab is successful.  FALSE if unsuccessful
+ * (e.g. no item, item is wall, item can't be grabbed).
+ */
 gboolean    g_robot_grab            (GRobot *robot);
+/** Zap the location in front of the robot.
+ *
+ * This action consumes energy.
+ *
+ * \param[in, out] robot A pointer to the robot doing the zapping.
+ *
+ * \returns TRUE if the zap is successful. Success only means the
+ * robot performed the zap; there may not have been anything in the
+ * location that was zappable.
+ */
 gboolean    g_robot_zap             (GRobot *robot);
+/** Stop the robot.  
+ *
+ * Usually indicates that the robot is done taking actions.  No more
+ * actions will succeed after the robot stops.
+ *
+ * \param[in, out] robot A pointer to the robot doing the stopping.
+ *
+ * \returns TRUE
+ */
 gboolean    g_robot_stop            (GRobot *robot);
+
+/** @} */
+
+/** \defgroup RStats Robot Statistics
+ * @{
+ *
+ * The statistics functions give infromation about the robot's current
+ * statistics, e.g. energy, shields, score...
+ */
+
+/** Return the number of turns (actions) the robot has performed.
+ *
+ * \param[in] robot A pointer to the robot.
+ *
+ * \returns the number of turns (actions) the robot has performed.
+ */
+glong       g_robot_get_turn        (GRobot *robot);
+/** Return the amount of shields the robot has.
+ *
+ * \param[in] robot A pointer to the robot.
+ *
+ * \returns the amount of shields robot has has.
+ */
 glong       g_robot_get_shields     (GRobot *robot);
+/** Return the amount of energy the robot has.
+ *
+ * \param[in] robot A pointer to the robot.
+ *
+ * \returns the amount of energy robot has has.
+ */
 glong       g_robot_get_energy      (GRobot *robot);
+/** Return the score the robot achieved.
+ *
+ * Score indicates the number of prizes the robot has collected.
+ *
+ * \param[in] robot A pointer to the robot.
+ *
+ * \returns the score robot has has achieved.
+ */
 glong       g_robot_get_score       (GRobot *robot);
+/** Return the amount of shots the robot has taken.
+ *
+ * \param[in] self A pointer to the robot.
+ *
+ * \returns the amount of shots the robot has taken.
+ */
+glong       g_robot_get_shots       (GRobot *self);
+
+/** @} */
+
+/** \defgroup RCosts Robot Action Energy Costs
+ * @{
+ *
+ * These functions return information on the normal costs of taking
+ * various Robot Actions.  They can be used by robot control programs
+ * to plan their energy budget.
+ */
+
+/** Get the energy cost for moving.
+ *
+ * \return the energy cost for moving.
+ */
+glong       g_robot_get_move_energy_cost();
+/** Get the energy cost for turning.
+ *
+ * \return the energy cost for turning.
+ */
+glong       g_robot_get_turn_energy_cost();
+/** Get the energy cost for feeling.
+ *
+ * \return the energy cost for feeling.
+ */
+glong       g_robot_get_feel_energy_cost();
+/** Get the energy cost for smelling.
+ *
+ * \return the energy cost for smelling.
+ */
+glong       g_robot_get_smell_energy_cost();
+/** Get the energy cost for looking.
+ *
+ * \return the energy cost for looking.
+ */
+glong       g_robot_get_look_energy_cost();
+/** Get the energy cost for grabbing.
+ *
+ * \return the energy cost for grabbing.
+ */
+glong       g_robot_get_grab_energy_cost();
+/** Get the energy cost for zapping.
+ *
+ * \return the energy cost for zapping.
+ */
+glong       g_robot_get_zap_energy_cost();
+
+/** @} */
+
+/**
+ * \defgroup RStatus Robot Status
+ * @{
+ */
+
+/** Determine if the robot is alive.
+ *
+ * The robot is alive it its energy and shields are both greater than
+ * zero and the robot has not been stopped.
+ * \sa g_robot_stop
+ *
+ * \param[in] self A pointer to the robot.
+ *
+ * \returns TRUE if the robot is alive; FALSE otherwise.
+ */
+gboolean    g_robot_is_alive        (GRobot *self);
+
+/** @} */
 
 G_END_DECLS
 
